/**********************************************************************\

File:		msg menus.h

Purpose:	This is the header file for msg menus.c


MSG Demo -- graphic effects demonstration program
Copyright (C) 1992-4 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

enum
{
	helpMenu = 200,
	crashMenu,
	
	appleMenu = 400,
	fileMenu,
	editMenu,
	wipesMenu,
	additionsMenu,
	scrollMenu,
	fluffMenu,
	
	aboutItem = 1,
	
	openItem = 1,
	closeItem,
	disableQuitItem = 4,
	enableQuitItem,
	quitItem = 7,
	
	undoItem = 1,
	cutItem = 3,
	copyItem,
	pasteItem,
	clearItem,
	
	spiralItem = 3,
	caste1Item = 5,
	rippleItem = 8,
	dissolveItem = 9,
	caste2Item = 11,
	
	serendipityItem = 9,
	bulgeItem = 10,
	splitScrollItem = 5,
	scrollInItem = 6,
	
	repeatItem = 1,
	reverseToggle,
	effectsOnlyItem = 4,
	effectsPlusFadesItem,
	reverseEffectsPlusFadesItem,
	fullScreenFadesItem,
	soundToggle = 9
};

extern	Boolean			gMenuEnabled;
extern	MenuHandle		gAppleMenu;
extern	MenuHandle		gFileMenu;
extern	MenuHandle		gEditMenu;
extern	MenuHandle		gWipesMenu;
extern	MenuHandle		gAdditionsMenu;
extern	MenuHandle		gScrollMenu;
extern	MenuHandle		gFluffMenu;
extern	MenuHandle		gHelpMenu;
extern	MenuHandle		gCrashMenu;

void AdjustMenus(void);
void HandleMenu(long mSelect);
void HandleAppleMenu(int menuItem);
void HandleFileMenu(int menuItem);
void HandleEditMenu(int menuItem);
void HandleWipesMenu(int menuItem);
void HandleAdditionsMenu(int menuItem);
void HandleScrollMenu(int menuItem);
void HandleHelpMenu(int menuItem);
void HandleFluffMenu(int menuItem);
void HandleCrashMenu(int menuItem);
void ReverseAllWipes(void);
