/**********************************************************************\

File:		msg sounds.c

Purpose:	This module handles playing syncronous and asyncronous
			sounds.


MSG Demo -- graphic effects demonstration program
Copyright (C) 1992-4 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg sounds.h"

SndChannelPtr		myChannel;
Handle				MySounds[NUM_SOUNDS];
Boolean				gSoundToggle;
Boolean				gSoundAvailable;

void InitSounds(void)
{
	int				i;
	
	gSoundAvailable=(SndNewChannel(&myChannel, 0, 0L, 0L)==noErr);
	if (!gSoundAvailable)
		myChannel=0;
	for (i=0; i<NUM_SOUNDS; i++)
		MySounds[i]=0L;
}

void DoSound(int whichSound, Boolean async)
{
	if (myChannel!=0)
	{
		SndDisposeChannel(myChannel, TRUE);
		myChannel=0;
	}
	
	whichSound-=1000;
	if ((gSoundToggle) && (gSoundAvailable))
	{
		if (!MySounds[whichSound])
			MySounds[whichSound]=GetResource('snd ', whichSound+1000);
		
		if (MySounds[whichSound])
		{
			if(SndNewChannel(&myChannel, 0, 0L, 0L) != noErr)					
			{
				myChannel = 0;
				gSoundAvailable = FALSE;
			}
			else SndPlay(myChannel, MySounds[whichSound], async);
		}
	}
}

void CloseSounds(void)
{
	if(myChannel)
		SndDisposeChannel(myChannel, TRUE);
}
